import config from '../../../config/app.config';
import { Category as CategoryToken } from '../entities/token.entity';
import { Token } from '../entities/token.entity';
import jwt = require('jsonwebtoken');
import { Connection } from 'typeorm';
import { MiscHelpers } from '../helpers';

export abstract class AuthService {
    /*
     * A FAKER getToken
    static async getToken(payload: object, category: CategoryToken, useragent: string): Promise<object> {
      return new Promise  (function (resolve, reject) {
            resolve({token: 'blahblahblah.....blah...'});
        });
    }
    */

    /**
     * getToken: Returns a signed token
     *
     * @param payload: the data items to be include in the signature
     * @param category: the type of the token (session, registration, password recovery)
     * @param useragent: the client's user agent
     * @returns: a signed token
    */
    static async getToken(payload: object, category: CategoryToken, useragent: string): Promise<object> {
        // We can specify the algorithm to protect the token (HS256 by default)
        // this way: { expiresIn: '1h', algorithm: HS384 }
        //          { expiresIn: '1h', algorithm: HS512}
        const dbConn: Connection = await MiscHelpers.getDbConnection();
        let token;
        let authToken;
        try {
                    authToken = jwt.sign(
                    payload,
                    process.env.SECRETTK,
                    { expiresIn: '24h',
                    algorithm: 'HS512' }
                    );      
                    token = new Token();
                    token.tk_token = authToken;
                    token.tk_category = category;
                    token.tk_status = true;
                    try {
                                await dbConn.getRepository(Token).save(token);
                                return new Promise (function (resolve, reject) {
                                    resolve({x_access_token: authToken});
                                });
                        } catch (error) {
                                console.log(error);
                                return new Promise  (function (resolve, reject) {
                                    reject({x_access_token: null});
                                });
                                
                        }
            } catch (error) {
                        console.log(error);
                        return new Promise  (function (resolve, reject) {
                            reject({x_access_token: null});
                        });
                        
            } 
    }
   

    /**
     * Decodes a token generated by this backend
     * 
     * @param token : The token to be validated by the Backend
     * @returns: an object representing the decoded token
     */

    static async getDecodedToken(token: string): Promise<object> {
        var result = {};
        const dbConn: Connection = await MiscHelpers.getDbConnection();
        try {
            const dbToken = await dbConn.getRepository(Token).findOne({ tk_token: token });
            if (dbToken) {
                if (dbToken.tk_status) {
                    try {
                        const decodedToken = await jwt.verify(token, process.env.SECRETTK);
                        result = {
                            code: 200,
                            data: { decodedToken : decodedToken }
                        };
                        // Token has been decoded succesfully
                        } catch (error) {
                        // Token could not be decoded. It might be out of date ...
                        result = {
                            code: 409,
                            data: { decodedToken : null}
                        };
                    }
                } else {
                    // Token has been invalidated. User might have logged out
                    result = {
                        code: 403,
                        data: { decodedToken: null}
                    };
                }
            } else {
                // Invalid token. It does not exist in the database
                result = {
                    code: 404,
                    data: { decodedToken: null}
                };
            }
        } catch (error) {
            result = {
                code: 500,
                data: { decodedToken : null}
            };
        }
        return new Promise(function (resolve, reject) {
            resolve(result);
        })
    }
}
